#include "consts.h"
#include "i_LM629.h"
#include "cmd_LM629.h"
#include "iPIC.h"


//VERIF CHARGEMENTS TRAJECTOIRE : LES AUTRES BITS ??? (poids fort)

signed int32 dest_pos1;
signed int32 dest_pos2;


//Initialisation des paramtres de trajectoire
void initLmData(int8 vitesse,int8 accel)
{
	//LM1
	execCmd1(LTRJ);
	//chargement vitesse + accel
	sendData1(LTRJ_BIT_ACCEL|LTRJ_BIT_VIT);
	sendData1(accel);sendData1(0x00);
	sendData1(vitesse);sendData1(0x00);
	
	//LM2
	execCmd2(LTRJ);
	//chargement vitesse + accel
	sendData2(LTRJ_BIT_ACCEL|LTRJ_BIT_VIT);
	sendData2(accel);sendData2(0x00);
	sendData2(vitesse);sendData2(0x00);
}

//Avance 1nb pas = 1cm  en ralit
void avance(int8 nb_pas,int8 sens)
{	
	if(sens == AVANCE_AV)
	{
		dest_pos1 = nb_pas;
		dest_pos2 = nb_pas;
		
	}
	else
	{
		dest_pos1 = nb_pas;
		dest_pos2 = nb_pas;

		dest_pos1 = 0x000-dest_pos1;
		dest_pos2 = 0x000-dest_pos2;		
	}
		
//	affiche_int8(nb_pas);
//	envoiCar(CAR_PAUSE);
//	affiche_int32(dest_pos2);
//	envoiCar(CAR_PAUSE);
//	dest_pos1 *= FACTEUR_POS;
//	dest_pos2 *= FACTEUR_POS;
	dest_pos1 = dest_pos1 * FACTEUR_POS * FACTEUR_POS2;
	dest_pos2 = dest_pos2 * FACTEUR_POS * FACTEUR_POS2;
	
	//affiche_int32(dest_pos1);

	startMvt();

	//envoiCar(CAR_PAUSE);

}

//Tourne  1 nb_pas = 1cm en ralit
void tourne(int8 nb_pas,int8 sens)
{	
	if(sens == TOURNE_D)
	{
		dest_pos1 = nb_pas;
		dest_pos2 = nb_pas;
		dest_pos2 = 0x000- dest_pos2;
	}
	else
	{
		dest_pos1 = nb_pas;
		dest_pos1 = 0x000- dest_pos1;
		dest_pos2 = nb_pas;
	}
	
//	dest_pos1 *= FACTEUR_POS;
//	dest_pos2 *= FACTEUR_POS;
	dest_pos1 = dest_pos1 * FACTEUR_POS * FACTEUR_POS2;
	dest_pos2 = dest_pos2 * FACTEUR_POS * FACTEUR_POS2;

//	affiche_int32(dest_pos1);
//	affiche_int32(dest_pos2);
	startMvt();
}

void startMvt()
{

	execCmd1(DFH);
	execCmd2(DFH);
	
	//LM1
	execCmd1(LTRJ);
	sendData1(LTRJ_BIT_POS);
	sendData1((dest_pos1 >> 16) & 0x0000FFFF);sendData1((dest_pos1) & 0x0000FFFF);

	//LM2
	execCmd2(LTRJ);
	sendData2(LTRJ_BIT_POS);
	sendData2((dest_pos2 >> 16) & 0x0000FFFF);sendData2((dest_pos2) & 0x0000FFFF);
	
	//Start
	execCmd1(STT);
	execCmd2(STT);

/*	readStatus1();
	readStatus2();
	envoicar("STAT");
	envoicar(CAR_PAUSE);	
	affiche_int8(g_data1);
	affiche_int8(g_data2);
	envoicar(CAR_PAUSE);*/	
}

#separate
void setVitesse(int8 val)
{
	int16 vitesse=0;
	float val2 ;
	
	val2 = val * FACTEUR_POS;
	//vitesse = 10;//abs(val2);
	
	vitesse = abs(val2);
	
//	affiche_int32(vitesse);	
	
	execCmd1(LTRJ);
	//chargement vitesse
	sendData1(LTRJ_BIT_VIT);
	sendData1(vitesse);sendData1(0x00); //actuellement seuls 16 bits sont envoy (on s'occupe pas des virgules)

	execCmd2(LTRJ);
	sendData2(LTRJ_BIT_VIT);
	sendData2(vitesse);sendData2(0x00); //actuellement seuls 16 bits sont envoy (on s'occupe pas des virgules)

}

#separate
void setAccel(int8 val)
{
	int16 acceleration=0;
	float val2 ;
	
	val2 = val * FACTEUR_POS;
	
	acceleration = abs(val2);
		
	//chargement accel
	execCmd1(LTRJ);
	sendData1(LTRJ_BIT_ACCEL);
	sendData1(acceleration);sendData1(0x00); //actuellement seuls 16 bits sont envoy (on s'occupe pas des virgules)

	execCmd2(LTRJ);
	sendData2(LTRJ_BIT_ACCEL);
	sendData2(acceleration);sendData2(0x00); //actuellement seuls 16 bits sont envoy (on s'occupe pas des virgules)

}

// Stop SANS MEMORISATION
void stop()
{
	//Arret Abrupt
	
	//LM1
	execCmd1(LTRJ);
	sendData1(LTRJ_HAND_BRAKE);
	execCmd1(STT);
	
	//LM2
	execCmd2(LTRJ);
	sendData2(LTRJ_HAND_BRAKE);
	execCmd2(STT);

}

// Stop AVEC MEMORISATION
int8 stop_temp() //arrte les moteurs et renvoie la distance parcourue EN CM
{
	int8 retour;
	int8 data;
	int16 dataLowLM;
	int16 dataHighLM;
	int32 Count;
	
	//Arret Abrupt 
	stop();

	execCmd1(RDRP);	//on prend la valeur sur 1 des LM.
	dataHighLM = readData1();
	dataLowLM = readData1();
	Count = make32(dataHighLM,dataLowLM);
	
	// on recolle en cm
	data = ((int32)abs(Count/FACTEUR_POS))>>16 & 0x00FF;
	
	return data;
}

void resume()
{
	//On reprend les derniers paramtres
	startMvt();
	readStatus1();
	readStatus2();
}

unsigned int8 waitForInt()
{
	unsigned int8 rep;	
	unsigned int1 pause;
	
	rep=0;
	pause = false;
	
	do
	{
		do
		{
			rep = readOctet_nblk();
			
			switch(rep)
			{
				case CMD_STOP :
					stop();	
					return;
					break;
				case CMD_STOP_TEMP :
					pause = true;
					stop();
					break;
				case CMD_RESUME :
					pause = false;
					resume();
					break;
			}
		} while(pause);

		readStatus1();
		readStatus2();
		
	} while( !((g_data1 | g_data2) & STATUS_ERRORS)
			&& !(g_data1 & g_data2 & STATUS_TRJ_END) );

	if(g_data1 & g_data2 & STATUS_TRJ_END)
	{
		//Trajectoire termine
		rep = TRJ_OK;
	}
	else
	{
		//Erreur survenue
		if((g_data1 | g_data2) & STATUS_DEP_ESP)
		{
			//Dpassement d'espace pour la position
			rep = ERR_DEP;
		}
		
		if((g_data1 | g_data2) & STATUS_POS_ERR)
		{
			//Erreur de position
			rep = ERR_POS;
		}
	}
	
	return rep;
}
// Rglage du coefficient proportionnel du PID des LM629
void regler_Proportionnel(int16 data)
{
	//LM629 N1
	execCmd1(LFIL);
	sendData1(0x08); //on charge le paramtre P !
	sendData1(data); //coef proportionnel==>poids faible
	execCmd1(UDF);
	
	//LM629 N2
	execCmd2(LFIL);
	sendData2(0x08); //on charge le paramtre P !
	sendData2(data); //coef proportionnel==>poids faible
	execCmd2(UDF);
	
	// Memorisation du coefficient proportionnel
	write_eeprom (EEPROM_PROP, data);
//	ajouter_trace(data);	
	
}

// Rglage du coefficient intgral du PID des LM629
void regler_Integral(int16 data)
{
	//LM629 N1
	execCmd1(LFIL);
	sendData1(0x04); //on charge le paramtre I !
	sendData1(data); //coef proportionnel==>poids faible
	execCmd1(UDF);

	//LM629 N2
	execCmd2(LFIL);
	sendData2(0x04); //on charge le paramtre I !
	sendData2(data); //coef proportionnel==>poids faible
	execCmd2(UDF);
	
	// Memorisation du coefficient Intgral
	write_eeprom (EEPROM_INT, data);

//	ajouter_trace(data);	
}

// Rglage du coefficient drive du PID des LM629
void regler_Derivee(int16 data)
{
	//LM629 N1
	execCmd1(LFIL);
	sendData1(0x02); //on charge le paramtre D !
	sendData1(data); //coef proportionnel==>poids faible
	execCmd1(UDF);

	//LM629 N2
	execCmd2(LFIL);
	sendData2(0x02); //on charge le paramtre D !
	sendData2(data); //coef proportionnel==>poids faible
	execCmd2(UDF);
	
	// Memorisation du coefficient driv
	write_eeprom (EEPROM_DER, data);

//	ajouter_trace(data);	
}


// Rglage de l'integral limit des LM629
void regler_intlimit(int16 data)
{
	execCmd1(LFIL);
	sendData1(0x01); //on charge le paramtre INTLIMIT !
	sendData1(data); //coef proportionnel==>poids faible
	execCmd1(UDF);

	//LM629 N2
	execCmd2(LFIL);
	sendData2(0x01); //on charge le paramtre INTLIMIT !
	sendData2(data); //coef proportionnel==>poids faible
	execCmd2(UDF);
	
	// Memorisation du coefficient drive
	write_eeprom (EEPROM_INTLIMIT, data);
//	ajouter_trace(data);	
}


#separate
void Afficher_Registres_LM1(int8 Type_registre)
{
	int16 rep_high;
	int16 rep_low;
	
	//envoiCar("DLM1");
	execCmd1(Type_registre);
	rep_high=readData1();
	rep_low=readData1();

	affiche_int32(MAKE32(rep_high,rep_low));
	envoiCar(CAR_PAUSE);
	//envoiCar("FLEC1");
	
}

#separate
void Afficher_Registres_LM2(int8 Type_registre)
{
	int16 rep_high;
	int16 rep_low;
	
	//envoiCar("DLM2");
	execCmd2(Type_registre);
	rep_high=readData2();
	rep_low=readData2();

	affiche_int32(MAKE32(rep_high,rep_low));
	envoiCar(CAR_PAUSE);
	//envoiCar("FLEC2");
	
}
