#include "iPIC.h"
#include "consts.h"

#use fast_io(A)

void testCmd()
{
/*	choix(CMD_PROPORTIONNEL,);
	choix(CMD_INTEGRAL,);
	choix(CMD_DERIVEE,);
	choix(CMD_INTLIMIT,);*/
	envoicar("TEST");
	envoicar(CAR_PAUSE);
	
	choix(CMD_AVANCE,20);

	envoicar("RDIP");
	envoicar(CAR_PAUSE);
	Afficher_Registres_LM1(RDIP);
	Afficher_Registres_LM2(RDIP);

	envoicar("RDDP");
	envoicar(CAR_PAUSE);
	Afficher_Registres_LM1(RDDP);
	Afficher_Registres_LM2(RDDP);

	//choix(CMD_STOP,1);
	
	envoicar(CAR_PAUSE);
	envoicar(CAR_PAUSE);
	envoicar(CAR_PAUSE);
	envoicar(CAR_PAUSE);
	envoicar(CAR_PAUSE);

	envoicar("RDIP");
	envoicar(CAR_PAUSE);
	Afficher_Registres_LM1(RDIP);
	Afficher_Registres_LM2(RDIP);

	envoicar("RDDP");
	envoicar(CAR_PAUSE);
	Afficher_Registres_LM1(RDDP);
	Afficher_Registres_LM2(RDDP);

}

void waitForCmd()
{
	unsigned int8 car=0;	//pour vrif bonne com.
	unsigned int8 data=0;	//pour donne dela commande
	unsigned int8 cmd=0;	//code de la commande
	unsigned int8 verif=0; //octet de vrification  
	char s_Action[5]="ACT.";

	set_tris_a(0xFF);
	envoiCar("ATT.");
	

	//while(1)
	//{
		// Attente et rcupration du 1er octet de vrification
		verif=readOctet();
		If (verif == BEGIN_TRANS)
		{
			//Si 1er octe  OK, on renvoie la valeur au PICBASIC (vrification que la transmission se fait correctement dans les 2 sens)
			envoiCar("ACK");
			
			sendOctet(BEGIN_TRANS);
			envoiCar("CMOK");
			
			// Rcup de l'octet de commande			
			cmd=readOctet();
			envoiCar("TYPE");
			
			sendOctet(BEGIN_TRANS);
			//Rcup de l'octet de donne
			data=readOctet();
			envoiCar("P.OK");
			

//			ajouter_trace(cmd);
//			ajouter_trace(data);

			//Recherche de la commande
			choix(cmd,data);
		}	

		else
		{
			envoiCar("ERR!");
			
			sendOctet(verif);
		}
	//}

}

#separate 
void choix(int8 cmd,int8 data)
{
		char s_Action[5]="****";
		
#ifdef SANS_PIC_BASIC
		set_tris_a(0xDF);
		output_low(PIC_DATA);
#endif //SANS_PIC_BASIC
		
			switch(cmd)
			{
				case CMD_SET_VITESSE :		//= 5
					envoiCar("VIT.");
					
					setVitesse(data);
					FinEnvoi(data);
					Write_EEPROM(EEPROM_MEM_VIT,data);
					break;
				case CMD_SET_ACCEL :		//= 6
					envoiCar("ACC.");
					
					setAccel(data);
					FinEnvoi(data);
					Write_EEPROM(EEPROM_MEM_ACC,data);
					break;
				case CMD_AVANCE :			//= 1
					envoiCar("AVT");
					envoicar(CAR_PAUSE);

					avance(data,AVANCE_AV); 
					FinEnvoi(data);
					break;
				case CMD_RECULE :			//= 2
					envoiCar("REC.");
					
					avance(data,AVANCE_RE);
					FinEnvoi(data);
					break;
				case CMD_TRN_GAUCHE :		//= 3
					envoiCar("GAU.");
					
					tourne(data,TOURNE_G);
					FinEnvoi(data);
					break;
				case CMD_TRN_DROITE :		//= 4
					envoiCar("DROI");
					
					tourne(data,TOURNE_D);
					FinEnvoi(data);
					break;
				case CMD_STOP :				//= 7
					envoiCar("STOP");
					
					stop();
					FinEnvoi(data);
					break;
				case CMD_STOP_TEMP :		//= 8
					envoiCar("STMP");
					envoicar(CAR_PAUSE);
					
					FinEnvoi(stop_temp());
					break;
				case CMD_RESUME :			//= 9
					envoiCar("RES.");
					
					resume();
					FinEnvoi(data);
					break;
				case CMD_PROPORTIONNEL :			//= 10
					envoiCar("PROP");
					
					regler_Proportionnel(data);
					FinEnvoi(data);
					Write_EEPROM(EEPROM_PROP,data);
					break;
				case CMD_INTEGRAL :			//= 11
					envoiCar("INTE");
					
					regler_integral(data);
					FinEnvoi(data);
					Write_EEPROM(EEPROM_INT,data);
					break;
				case CMD_DERIVEE :			//= 12
					envoiCar("DERV");
					
					regler_derivee(data);
					FinEnvoi(data);
					Write_EEPROM(EEPROM_DER,data);
					break;
				case CMD_INTLIMIT :			//= 13
					envoiCar("INTL");
					
					regler_intlimit(data);
					FinEnvoi(data);
					Write_EEPROM(EEPROM_INTLIMIT,data);					
					break;
				case CMD_PURGE_TRACE :			//= 14
					envoiCar("PURG");
					
					purge_trace();
					FinEnvoi(data);
					break;
				case CMD_LIRE_TRACE :			//= 15
					envoiCar("TRAC");
					
					lire_trace();
					FinEnvoi(data);
					break;
				case CMD_LIRE_PID :			//= 16
					envoiCar("PID?");
					
					lire_PID();
					FinEnvoi(data);
					break;
				default :
					sendOctet(CMD_INCONNUE);
					//return;
					break;
			}
			
}

void FinEnvoi(int8 data)
{
	sendOctet(data);
	EnvoiCar("F OK");
	EnvoiCar(CAR_PAUSE);
}


// Lit un octet issu du PICBASIC
unsigned int8 readOctet()
{
	unsigned int8 res;
	unsigned int8 i;

	res = 0x00;

	set_tris_a(0xFF);

	// Attente du crneau de dpart, lanc par le PICBASIC
	attendSignal_creneau();

	// Lecture
	for(i=0;i<8;i++)
	{
		//Rcupration du signal, synchronis avec le signal de clock
		while(!input(PIC_CLOCK))
			continue;	
		while(input(PIC_CLOCK))
		{
			if(input(PIC_DATA))
			res |= (0x01<<i);
			//attendSignal();
		}

	}
	return res;
}

// Lit un octet issu du PICBASIC
//non bloquant
unsigned int8 readOctet_nblk()
{
	unsigned int8 res;
	unsigned int8 i;

	res = 0x00;

	set_tris_a(0xFF);

	// Attente du crneau de dpart, lanc par le PICBASIC
	if(attendSignal_creneau_nblk())
	{
	
		// Lecture
		for(i=0;i<8;i++)
		{
			//Rcupration du signal, synchronis avec le signal de clock
			while(!input(PIC_CLOCK))
				continue;	
			while(input(PIC_CLOCK))
			{
				if(input(PIC_DATA))
				res |= (0x01<<i);
				//attendSignal();
			}
	
		}
	}
	return res;
}

#ifndef SANS_PIC_BASIC
// Envoie un octet au PICBASIC
void sendOctet(unsigned int8 oct)
{
	unsigned int8 i=0;

	set_tris_a(0xDF);
	//Crneau de synchronisation
	while(!input(PIC_CLOCK))
		continue;	
	while(input(PIC_CLOCK))
		output_high(PIC_DATA);

	//On place tout de suite le 1er bit  transmettre
	if( (oct &  (0x01<<i)) == 0) 
		output_low(PIC_DATA);
	else
		output_high(PIC_DATA);
		
	for(i=0;i<8;i++)
	{
		//Envoi de l'octet, synchronis avec le signal de clock
		while(!input(PIC_CLOCK))
		{
			if( (oct &  (0x01<<i)) == 0) 
				output_low(PIC_DATA);
			else
				output_high(PIC_DATA);
		}
		while(input(PIC_CLOCK))
		{
			if( (oct &  (0x01<<i)) == 0) 
				output_low(PIC_DATA);
			else
				output_high(PIC_DATA);
		}
				
	}
		// Crneau 
		while(!input(PIC_CLOCK))
			continue;
		while(input(PIC_CLOCK))
			continue;

	output_low(PIC_DATA);
	set_tris_a(0xFF);
}
#else //SANS_PIC_BASIC
//il n'y a pas de pic-basic !!!
void sendOctet(unsigned int8 oct)
{
	envoiCar("PIC");
	envoiCar(oct);
	envoiCar(CAR_PAUSE);
}
#endif //SANS_PIC_BASIC


#inline

// Boucle d'attente de crneau du PICBASIC
void attendSignal_creneau()
{
	if (!input(PIC_CLOCK))
		{
		// Crneau complet
		while(!input(PIC_CLOCK))
			continue;
		while(input(PIC_CLOCK))
			continue;
		while(!input(PIC_CLOCK))
			continue;
		}
	else
		{
		//Fin du crneau
		while(input(PIC_CLOCK))
			continue;
		while(!input(PIC_CLOCK))
			continue;
		}

}

// Boucle d'attente de crneau du PICBASIC
//non bloquant (time out)	
int1 attendSignal_creneau_nblk()
{
	int i=SIG_CRE_TIMEOUT;
	if (!input(PIC_CLOCK))
		{
		// Crneau complet
		while(!input(PIC_CLOCK) && i>0)
			i--;
		if(i<=0)
			return 0;
		
		while(input(PIC_CLOCK) && i>0)
			i--;
		if(i<=0)
			return 0;

		while(!input(PIC_CLOCK) && i>0)
			i--;

		if(i<=0)
			return 0;

		}
	else
		{
		//Fin du crneau
		while(input(PIC_CLOCK) && i>0)
			i--;
		if(i<=0)
			return 0;

		while(!input(PIC_CLOCK) && i>0)
			i--;
		if(i<=0)
			return 0;
		}
	return 1;
}


// Boucle d'attente 
void attendSignal()
{
		while(input(PIC_CLOCK))
			continue;
		while(!input(PIC_CLOCK))
			continue;
}

// Boucle d'attente des fronts descendants du PICBASIC
void attendRead()
{
		while(!input(PIC_CLOCK))
			continue;
		while(input(PIC_CLOCK))
			continue;
}

// Boucle d'attente des fronts montants du PICBASIC
void attendSignal_desc_mont()
{
		while(!input(PIC_CLOCK))
			continue;
}

#use standard_io(A)

#use standard_io(A)
