#include "consts.h"
#include "envcar.h"
#include "i_lm629.h"
#include "cmd_lm629.h"

//Pour tre sr des registres de direction
#use fast_io(B)
#use fixed_io(c_outputs=PIN_C0, PIN_C1, PIN_C2, PIN_C4, PIN_C5)

#inline
void test_lm()
{
	//on charge les paramtres du filtre
	//pour l'instant, c'est un peu n'importe quoi :)
	execCmd1(LFIL);
	sendData1(0x0F); //on charge les 4 paramtres !
	sendData1(0x0F); //coef proportionnel
	sendData1(0x0F); //coef intgral
	sendData1(0x0F); //coef driv
	sendData1(0x0F); //integral limit
	//ouf!
	
	execCmd1(UDF); //valider les paramtres du filtre
	
	//c'est ici la position de dpart
	execCmd1(DFH);
	
	//trajectoire
	execCmd1(LTRJ);
	sendData1(LTRJ_BIT_ACCEL | LTRJ_BIT_VIT | LTRJ_BIT_POS); //on charge les trois paramtres
	sendData1(0x0A); //acclration
	sendData1(0x0B); //vitesse
	sendData1(0x0C); //position
}

void output_data(int8 data)
{
	//Le fast_io est un peu trop fast !
	//deux critures sucessives peuvent masquer la premire
	set_tris_b(0x00);
	//delay_cycles(200);
	delay_ms(5);
	output_b(data);
	//delay_cycles(200);
	delay_ms(5);
	output_low(WR);
	//delay_cycles(200);
	delay_ms(5);
	output_high(WR);
	set_tris_b(0xFF);
}

#inline
int8 input_data()
{
    int8 data;
	set_tris_b(0xFF); //Port b en entre
	output_low(RD);
	delay_cycles(100);
	data = input_b();
	delay_cycles(100);
	output_high(RD);
	return data;
}

void initLM()
{
	int8 cpt;
		
	//Port B en lecture
	set_tris_b(0xFF);
	
	output_high(CS1);
	output_high(CS2);
	output_high(WR);
	output_high(RD);
	
	//Hardware Reset
	do
	{
		do
		{
			envoiCar("RST");
			delay_cycles(100);
			//Reset
			envoiCar(CAR_RST);
			for(cpt=10;cpt>0;cpt--)
				delay_cycles(200);//Il faut laisser la broche reset  l'tat bas pendant au moins 10 priodes. FAIT PAR LE 16F84!
			envoiCar(CAR_CLR);
			for(cpt=2000;cpt>0;cpt--)
				delay_cycles(100);//il faut ensuite attendre au moins 1,5 ms pour lire l'octet de status et
								  //vrifier le reset
			//Vrification
			readStatus1();
			readStatus2();

			envoiCar(CAR_PAUSE);
			for(cpt=20000;cpt>0;cpt--)
				delay_cycles(100);
			//return;
		} while( 	( g_data1!=0xC4 && g_data1!=0x84 )
				||  ( g_data2!=0xC4 && g_data2!=0x84 ) );
		
		//return;
		envoiCar("RSOK");
		delay_cycles(400);
		
		//Interrupts Reset
		execCmd1(RSTI);
		sendData1(0x00);
		
		execCmd2(RSTI);
		sendData2(0x00);
		
		//Vrification
		readStatus1();
		readStatus2();
		
	} while(( g_data1!=0xC0 && g_data1!=0x80 )
		||	( g_data2!=0xC0 && g_data2!=0x80 ) );
	
	{
		envoiCar("OK!");
		envoiCar(CAR_PAUSE);
	}
	// Paramtres par dfaut
	
	
	setVitesse(read_eeprom(EEPROM_MEM_VIT));

	if (( g_data1!=0xC0 && g_data1!=0x80 )
		||	( g_data2!=0xC0 && g_data2!=0x80 ) )
	{	
		envoiCar("VIT!");
		envoiCar(CAR_PAUSE);
		envoiCar("V1");
		affiche_int8(g_data1);
		envoiCar(CAR_PAUSE);
		envoiCar("V2");
		affiche_int8(g_data2);
		envoiCar(CAR_PAUSE);
		
	}

	// ACCELERATION
	setAccel(read_eeprom(EEPROM_MEM_ACC));
	if (( g_data1!=0xC0 && g_data1!=0x80 )
		||	( g_data2!=0xC0 && g_data2!=0x80 ) )
	{	
		envoiCar("ACC!");
		envoiCar(CAR_PAUSE);
		envoiCar("A1");
		affiche_int8(g_data1);
		envoiCar(CAR_PAUSE);
		envoiCar("A2");
		affiche_int8(g_data2);
		envoiCar(CAR_PAUSE);
		
	}

	// PROPORTIONNEL	
	regler_Proportionnel(read_eeprom(EEPROM_PROP));
	if (( g_data1!=0xC0 && g_data1!=0x80 )
		||	( g_data2!=0xC0 && g_data2!=0x80 ) )
	{	
		envoiCar("PRO!");
		envoiCar(CAR_PAUSE);
		envoiCar("P1");
		affiche_int8(g_data1);
		envoiCar(CAR_PAUSE);
		envoiCar("P2");
		affiche_int8(g_data2);
		envoiCar(CAR_PAUSE);
	}

	// INTEGRAL
	regler_Integral(read_eeprom(EEPROM_INT));
	if (( g_data1!=0xC0 && g_data1!=0x80 )
		||	( g_data2!=0xC0 && g_data2!=0x80 ) )
	{	
		envoiCar("INT!");
		envoiCar(CAR_PAUSE);
		envoiCar("I1");
		affiche_int8(g_data1);
		envoiCar(CAR_PAUSE);
		envoiCar("I2");
		affiche_int8(g_data2);
		envoiCar(CAR_PAUSE);
	}
	
	// DERIVEE
	regler_Derivee(read_eeprom(EEPROM_DER));
	if (( g_data1!=0xC0 && g_data1!=0x80 )
		||	( g_data2!=0xC0 && g_data2!=0x80 ) )
	{	
		envoiCar("DER!");
		envoiCar(CAR_PAUSE);
		envoiCar("D1");
		affiche_int8(g_data1);
		envoiCar(CAR_PAUSE);
		envoiCar("D2");
		affiche_int8(g_data2);
		envoiCar(CAR_PAUSE);
	}
	


	// INTEGRAL LIMIT
	regler_intlimit(read_eeprom(EEPROM_INTLIMIT));
	if (( g_data1!=0xC0 && g_data1!=0x80 )
		||	( g_data2!=0xC0 && g_data2!=0x80 ) )
	{	
		envoiCar("IL!");
		envoiCar(CAR_PAUSE);
		envoiCar("L1");
		affiche_int8(g_data1);
		envoiCar(CAR_PAUSE);
		envoiCar("L2");
		affiche_int8(g_data2);
		envoiCar(CAR_PAUSE);
	}

	envoiCar("FPID");
	envoiCar(CAR_PAUSE);
}

void readStatus1()
{
	output_low(CS1);
	output_low(PS);
	output_low(RD);
	delay_cycles(200);
	g_data1 = input_data();


	if (bit_test(g_data1,1) == 1 )
	{

		envoiCar("STA1");
		envoiCar(CAR_PAUSE);
		affiche_int8(g_data1);
		envoiCar(CAR_PAUSE);
		ajouter_trace(g_data1);
		
	}

	output_high(RD);
	output_high(CS1);
	delay_cycles(200);
}

void readStatus2()
{
	output_low(CS2);
	output_low(PS);
	output_low(RD);
	delay_cycles(200);
	g_data2 = input_data();

	if (bit_test(g_data2,1) == 1 )
	{
		
		envoiCar("STA2");
		envoiCar(CAR_PAUSE);
		affiche_int8(g_data2);
		envoiCar(CAR_PAUSE);

		ajouter_trace(g_data2);
		
	}
	
	output_high(RD);
	output_high(CS2);
	delay_cycles(200);
}

void chkBusy1()
{
	
	readStatus1();
	while(g_data1 & 0x01)
		readStatus1();
		
}

void chkBusy2()
{
	readStatus2();
	while(g_data2 & 0x01)
		readStatus2();
}

void execCmd1(unsigned int8 cmd)
{
	chkBusy1();
	output_low(CS1);
	output_low(PS); //pour crire cmd
	
	output_data(cmd);
	
	output_high(CS1);
	
}

void execCmd2(unsigned int8 cmd)
{
	chkBusy2();
	output_low(CS2);
	output_low(PS); //pour crire cmd
	
	output_data(cmd);
	
	output_high(CS2);
}

void sendData1(unsigned int16 data)
{
	chkBusy1();
	output_low(CS1);
	output_high(PS); //pour crire data
	
	output_data( (data >> 8) & 0x00FF);
	output_data( (data) & 0x00FF);
	
	output_high(CS1);
}

void sendData2(unsigned int16 data)
{
	chkBusy2();
	output_low(CS2);
	output_high(PS); //pour crire data
	
	output_data( (data >> 8) & 0x00FF);
	output_data( (data) & 0x00FF);
	
	output_high(CS2);
}

int16 readData1()
{
	int8 varhigh;
	int8 varlow;
	int16 retour;
	
	// vrification
	chkBusy1();
	
	// selection du chip n1
	output_low(CS1);
	output_high(PS); //pour lire data
	varlow = input_data(); //1er octet (poids faible)
	
//	ajouter_trace(varlow);

	//2eme octet (poids fort)
	delay_cycles(200);
	varhigh = input_data();

//	ajouter_trace(varhigh);
	
	// Rsultat sur 2 octets
	retour =MAKE16(varhigh, varlow);

	output_high(CS1);

	return retour;
}

int16 readData2()
{
	int8 varhigh;
	int8 varlow;
	int16 retour;
	
	// vrification
	chkBusy2();
	
	// selection du chip n2
	output_low(CS2);
	output_high(PS); //pour lire data
	varlow = input_data(); //1er octet (poids faible)
	
//	ajouter_trace(varlow);
	
	//2eme octet (poids fort)
	delay_cycles(200);
	varhigh = input_data();
	
//	ajouter_trace(varhigh);	
	
	// Rsultat sur 2 octets
	retour = MAKE16(varhigh, varlow);


	output_high(CS2);

	return retour;

}

void lire_PID()
{
envoicar("RDDP");
envoicar(CAR_PAUSE);
Afficher_Registres_LM2(RDDP);

envoicar("RDRP");
envoicar(CAR_PAUSE);
Afficher_Registres_LM2(RDRP);

envoicar("RDDV");
envoicar(CAR_PAUSE);
Afficher_Registres_LM2(RDDV);

envoicar("RDRV");
envoicar(CAR_PAUSE);
Afficher_Registres_LM2(RDRV);

envoicar("RDSU");
envoicar(CAR_PAUSE);
Afficher_Registres_LM2(RDSUM);
}


#use standard_io(B)


