#include "consts.h"
#include "envcar.h"
#include "i_lm629.h"

//Pour tre sr des registres de direction
#use fast_io(B)
#use fixed_io(c_outputs=PIN_C0, PIN_C1, PIN_C2, PIN_C4, PIN_C5)

void output_data(int8 data)
{
	//Le fast_io est un peu trop fast !
	//deux critures sucessives peuvent masquer la premire
	set_tris_b(0x00);
	delay_cycles(100);
	output_b(data);
	delay_cycles(100);
	output_low(WR);
	delay_cycles(100);
	output_high(WR);
	set_tris_b(0xFF);
}

#inline
int8 input_data()
{
	set_tris_b(0xFF); //Port b en entre
	output_low(RD);
	delay_cycles(100);
	return input_b();
	delay_cycles(100);
	output_high(RD);
}

void initLM()
{
//	lm1 g_data;
	int8 cpt;
	char s_aff[5] = " ";
		
	//Port B en lecture
	set_tris_b(0xFF);
	
	output_high(CS1);
	output_high(CS2);
	output_high(WR);
	output_high(RD);
	

	//Hardware Reset
	do
	{
		strcpy(s_aff,"RSOK");
		envoiStr(s_aff,4);
		do
		{
			strcpy(s_aff,"RST.");
			envoiStr(s_aff,4);
			delay_cycles(100);
			//Reset
			envoiCar(CAR_RST);
			for(cpt=10;cpt>0;cpt--)
				delay_cycles(200);//Il faut laisser la broche reset  l'tat bas pendant au moins 10 priodes. FAIT PAR LE 16F84!
			envoiCar(CAR_CLR);
			for(cpt=2000;cpt>0;cpt--)
				delay_cycles(100);//il faut ensuite attendre au moins 1,5 ms pour lire l'octet de status et
								  //vrifier le reset
			//Vrification
			readStatus1();
			readStatus2();
			if(g_data1==0)
				envoiCar("0");
			else
				envoiCar("1");
				
			if(g_data2==0)
				envoiCar("0");
			else
				envoiCar("1");

			envoiCar(CAR_PAUSE);
			for(cpt=20000;cpt>0;cpt--)
				delay_cycles(100);
			//return;
		} while( 	( g_data1!=0xC4 && g_data1!=0x84 )
				||  ( g_data2!=0xC4 && g_data2!=0x84 ) );
		
		return;
		strcpy(s_aff,"OK!!");
		envoiStr(s_aff,4);

		delay_cycles(400);
		
		//Interrupts Reset
		execCmd1(RSTI);
		sendData1(0x00);
		
		execCmd2(RSTI);
		sendData2(0x00);
		
		//Vrification
		
		readStatus1();
		readStatus2();
		
	} while(( g_data1!=0xC0 && g_data1!=0x80 )
		||	( g_data2!=0xC0 && g_data2!=0x80 ) );
	
	{
		strcpy(s_aff,"OK!!");
		envoiStr(s_aff,4);
	}
}

#separate
void readStatus1()
{
	output_low(CS1);
	output_low(PS);
	output_low(RD);
	delay_cycles(200);
	g_data1 = input_data();
	output_high(RD);
	output_high(CS1);
	delay_cycles(200);
	ajouter_trace(g_data1);
	//affiche_int8(g_data1);
}

#separate
void readStatus2()
{
	output_low(CS2);
	output_low(PS);
	output_low(RD);
	delay_cycles(200);
	g_data2 = input_data();
	output_high(RD);
	output_high(CS2);
	delay_cycles(200);
	ajouter_trace(g_data1);	
	//affiche_int8(g_data1);
}

#separate
void chkBusy1()
{
	
	readStatus1();
	while(g_data1 & 0x01)
		readStatus1();
		
}

#separate
void chkBusy2()
{
	readStatus2();
	while(g_data2 & 0x01)
		readStatus2();
}

#separate
void execCmd1(unsigned int8 cmd)
{
	chkBusy1();
	output_low(CS1);
	output_low(PS); //pour crire cmd
	
	output_data(cmd);
	
	output_high(CS1);
	
}

#separate
void execCmd2(unsigned int8 cmd)
{
	chkBusy2();
	output_low(CS2);
	output_low(PS); //pour crire cmd
	
	output_data(cmd);
	
	output_high(CS2);
}

#separate
void sendData1(unsigned int16 data)
{
	chkBusy1();
	output_low(CS1);
	output_high(PS); //pour crire data
	
	output_data( (data >> 8) & 0x00FF);
	output_data( (data) & 0x00FF);
	
	output_high(CS1);
}

#separate
void sendData2(unsigned int16 data)
{
	chkBusy2();
	output_low(CS2);
	output_high(PS); //pour crire data
	
	output_data( (data >> 8) & 0x00FF);
	output_data( (data) & 0x00FF);
	
	output_high(CS2);
}

#separate
int16 readData1()
{
	int8 varhigh;
	int8 varlow;
	int16 retour;
	
	// vrification
	chkBusy1();
	
	// selection du chip n1
	output_low(CS1);
	output_high(PS); //pour lire data
	varlow = input_data(); //1er octet (poids faible)
	
	//2eme octet (poids fort)
	delay_cycles(200);
	varhigh = input_data();
	
	// Rsultat sur 2 octets
	retour =MAKE16(varhigh, varlow);

	output_high(CS1);

	//affiche_int16(retour);

	return retour;
}

#separate
int16 readData2()
{
	int8 varhigh;
	int8 varlow;
	int16 retour;
	
	// vrification
	chkBusy2();
	
	// selection du chip n2
	output_low(CS2);
	output_high(PS); //pour lire data
	varlow = input_data(); //1er octet (poids faible)

	//2eme octet (poids fort)
	delay_cycles(200);
	varhigh = input_data();
	
	// Rsultat sur 2 octets
	retour =MAKE16(varhigh, varlow);


	output_high(CS2);
	
	//affiche_int16(retour);
	
	return retour;

}

// Rglage du coefficient proportionnel du PID des LM629
void regler_Proportionnel(int8 data)
{
	int8 coef_integral;
	int8 coef_derivee;
	int8 coef_intlimit;

	//Rcupration dans l'eeprom du PIC les valeurs de coefs non modifis
	coef_integral = Read_eeprom(EEPROM_INT);
	coef_derivee = Read_eeprom(EEPROM_DER);
	coef_intlimit = Read_eeprom(EEPROM_INTLIMIT);
	
	//LM629 N1
	execCmd1(LFIL);
	sendData1(0x0F); //on charge les 4 paramtres !
	sendData1(data); //coef proportionnel
	sendData1(coef_integral); //coef intgral
	sendData1(coef_derivee); //coef driv
	sendData1(coef_intlimit); //integral limit


	//LM629 N2
	execCmd2(LFIL);
	sendData2(0x0F); //on charge les 4 paramtres !
	sendData2(data); //coef proportionnel
	sendData2(coef_integral); //coef intgral
	sendData2(coef_derivee); //coef driv
	sendData2(coef_intlimit); //integral limit
	
	// Memorisation du coefficient proportionnel
	write_eeprom (EEPROM_PROP, data);

	
}

// Rglage du coefficient intgral du PID des LM629
void regler_Integral(int8 data)
{
	int8 coef_proportionnel;
	int8 coef_derivee;
	int8 coef_intlimit;

	//Rcupration dans l'eeprom du PIC les valeurs de coefs non modifis
	coef_proportionnel = Read_eeprom(EEPROM_PROP);
	coef_derivee = Read_eeprom(EEPROM_DER);
	coef_intlimit = Read_eeprom(EEPROM_INTLIMIT);
	
	//LM629 N1
	execCmd1(LFIL);
	sendData1(0x0F); //on charge les 4 paramtres !
	sendData1(coef_proportionnel); //coef proportionnel
	sendData1(data); //coef intgral
	sendData1(coef_derivee); //coef driv
	sendData1(coef_intlimit); //integral limit
	
	//LM629 N2
	execCmd2(LFIL);
	sendData2(0x0F); //on charge les 4 paramtres !
	sendData2(coef_proportionnel); //coef proportionnel
	sendData2(data); //coef intgral
	sendData2(coef_derivee); //coef driv
	sendData2(coef_intlimit); //integral limit

	// Memorisation du coefficient Intgral
	write_eeprom (EEPROM_INT, data);
	
}

// Rglage du coefficient drive du PID des LM629
void regler_Derivee(int8 data)
{
	int8 coef_proportionnel;
	int8 coef_derivee;
	int8 coef_intlimit;
	int8 coef_integral;
	
	//Rcupration dans l'eeprom du PIC les valeurs de coefs non modifis
	coef_proportionnel = Read_eeprom(EEPROM_PROP);
	coef_integral = Read_eeprom(EEPROM_INT);
	coef_intlimit = Read_eeprom(EEPROM_INTLIMIT);

	//LM629 N1	
	execCmd1(LFIL);
	sendData1(0x0F); //on charge les 4 paramtres !
	sendData1(coef_proportionnel); //coef proportionnel
	sendData1(coef_integral); //coef intgral
	sendData1(data); //coef driv
	sendData1(coef_intlimit); //integral limit

	
	//LM629 N2
	execCmd2(LFIL);
	sendData2(0x0F); //on charge les 4 paramtres !
	sendData2(coef_proportionnel); //coef proportionnel
	sendData2(coef_integral); //coef intgral
	sendData2(data); //coef driv
	sendData2(coef_intlimit); //integral limit

	// Memorisation du coefficient drive
	write_eeprom (EEPROM_DER, data);
}


// Rglage de l'integral limit des LM629
void regler_intlimit(int8 data)
{
	int8 coef_proportionnel;
	int8 coef_derivee;
	int8 coef_intlimit;
	int8 coef_integral;
	
	//Rcupration dans l'eeprom du PIC les valeurs de coefs non modifis
	coef_proportionnel = Read_eeprom(EEPROM_PROP);
	coef_integral = Read_eeprom(EEPROM_INT);
	coef_derivee = Read_eeprom(EEPROM_DER);
	
	//LM629 N1
	execCmd1(LFIL);
	sendData1(0x0F); //on charge les 4 paramtres !
	sendData1(coef_proportionnel); //coef proportionnel
	sendData1(coef_integral); //coef intgral
	sendData1(coef_derivee); //coef driv
	sendData1(data); //integral limit

	//LM629 N2
	execCmd2(LFIL);
	sendData2(0x0F); //on charge les 4 paramtres !
	sendData2(coef_proportionnel); //coef proportionnel
	sendData2(coef_integral); //coef intgral
	sendData2(coef_derivee); //coef driv
	sendData2(data); //integral limit
	
	// Memorisation du coefficient drive
	write_eeprom (EEPROM_INTLIMIT, data);
	
}



#use standard_io(B)


